MESSAGE(STATUS "Transforming keyboard shortcuts ${INPUT} -> ${OUTPUT}")

SET(MANUAL_MENU_PATTERN       	"#menu\\(([^)]+)\\)")
SET(MANUAL_MENU_REPLACEMENT   	"<script>print_menu_item(\"\\1\");</script>")
SET(MANUAL_ACTION_PATTERN     	"#action\\(([^)]+)\\)")
SET(MANUAL_ACTION_REPLACEMENT	"<script>print_action(\"\\1\");</script>")
SET(MANUAL_KEY_PATTERN 	    	"#key\\(([0-9]+)\\)")
SET(MANUAL_KEY_REPLACEMENT 		"<script>print_key(\\1);</script>")

FILE(READ "${INPUT}" MANUAL_CONTENTS)
STRING(REGEX REPLACE "${MANUAL_MENU_PATTERN}"   "${MANUAL_MENU_REPLACEMENT}"   MANUAL_CONTENTS "${MANUAL_CONTENTS}")
STRING(REGEX REPLACE "${MANUAL_ACTION_PATTERN}" "${MANUAL_ACTION_REPLACEMENT}" MANUAL_CONTENTS "${MANUAL_CONTENTS}")
STRING(REGEX REPLACE "${MANUAL_KEY_PATTERN}"    "${MANUAL_KEY_REPLACEMENT}"    MANUAL_CONTENTS "${MANUAL_CONTENTS}")
FILE(WRITE "${OUTPUT}" "${MANUAL_CONTENTS}")
